"""
Provides methods to convert environmental variables into configuration values
"""

import os
import re

# Fixes tzlocal warning
# UserWarning: Can not find any timezone configuration, defaulting to UTC
if os.getenv('TZ', None) is None:
 os.environ['TZ'] = 'Europe/London'

#-------------------------------------------------------------------------------
def get_sso_host():
 """ Gets the env value for SSO_HOST """
 return os.getenv('SSO_HOST', 'www.malariagen.net')

#-------------------------------------------------------------------------------
def parse_database_url(url):
 """ Parses the provided url into a dict containing database connection details"""
 #Support postgres://user:password@postgres-host:postgres-port/postgres-database
 allowed_characters = "[\x20-\x7E]"
 db_url_regex = r"postgres\:\/\/({0}+)\:({0}+)\@({0}+)\:(\d+)\/({0}+)"
 parser = re.compile(db_url_regex.format(allowed_characters))
 details = parser.match(url)
 if details is None:
  return (False, "{} is not a valid database url".format(url))

 if len(details.groups()) < 5:
  return(False, "Not all groups where met. Expected 5, got {}".format(len(details.groups())))

 return (True, {
     'user': details.group(1),
     'database': details.group(5),
     'password': details.group(2),
     'host': details.group(3),
     'port': details.group(4),
     })


#-------------------------------------------------------------------------------
def get_connection_config():
 """ Return a dict for a database connection either using environmental variable
 `database_url` or a set of enviromental variables that start with `POSTGRES_`"""

 config = None
 #Issue #13 https://gitlab.com/malariagen/conflux/api-service

 db_url = os.getenv('DATABASE_URL', None)
 if db_url:
  parse_results = parse_database_url(db_url)
  if parse_results[0]:
   config = parse_results[1]

 if config is None:
  config = {
      'user': os.getenv('POSTGRES_USER', os.getenv('USER')),
      'database': os.getenv('POSTGRES_DB', 'backbone_service'),
      'password': os.getenv('POSTGRES_PASSWORD', None),
      'host': os.getenv('POSTGRES_HOST', 'localhost'),
      'port': os.getenv('POSTGRES_PORT', '5432'),
  }

 return config

#-------------------------------------------------------------------------------
def get_sds_connection():
 """ Gets connection details for simple data store"""
 return {
     'bucket': os.getenv('SDS_BUCKET', None),
     'access': os.getenv('SDS_ACCESS', None),
     'secret': os.getenv('SDS_SECRET', None)
 }

#-------------------------------------------------------------------------------
def get_connection_url():
 """ Converts the connection dict generated by get_connection_config
 into a url connection"""
 config = get_connection_config()
 url = 'postgresql+psycopg2://' + config['user']
 if config['password']:
  url += ':' + config['password']
 url += '@' + config['host']
 url += ':' + config['port']
 url += '/' + config['database']

 return url
